/** @file
 *
 * Color lookup and functions
 *
 * @author Paul Pantalone
 * @copyright Paul Pantalone. All Rights Reserved
 * @date 2020
 */
#pragma once
#include <elements/export.h>
#include <elements/Color.h>

namespace pdp {

enum ColorLookup
{
  ColorLookupGrey = 0,
  ColorLookupInverseGrey,
  ColorLookupYellow,
  ColorLookupPurple,
  ColorLookupHotGreen,
  ColorLookupHotBlue,
  ColorLookupHotIron,
  ColorLookupBlackbody,
  ColorLookupHeat,
  ColorLookupSpectrum1,
  ColorLookupSpectrum2,
  ColorLookupNih,
  ColorLookupGE,
  ColorLookupColorBand,
  ColorLookupWarp,
  ColorLookupRainbow
};

PDPELEMENTS_EXPORT void loadColorLookup(
  ColorLookup lookup,
  std::vector<Color>& colorLookupTable);

} // namespace pdp
