/** @file
 *
 * ByteArrayInputStreambuf
 *
 * @author Paul Pantalone
 * @copyright Paul Pantalone. All Rights Reserved
 * @date 2018
 */
#pragma once

#include <streambuf>
#include <models/ModelR3f.h>
#include <qtElements/export.h>

class QByteArray;

class PDPQTELEMENTS_EXPORT ByteArrayInputStreambuf : public std::streambuf
{
public:
  /**
   * Takes a pointer to the char vector to be used to store the data.  Note
   * ownership of the data pointer is retained by the caller
   */
  explicit ByteArrayInputStreambuf(
    QByteArray* data);

  /**
   * Returns a const reference to the internal data container
   */
  const QByteArray& data() const;

  /**
   * Virtual destructor
   */
  virtual ~ByteArrayInputStreambuf();

private:
  mutable QByteArray* m_data;
};

PDPQTELEMENTS_EXPORT pdp::ModelR3f* loadModelFromResources(
  const std::string& modelName);
