/** @file
 *
 * QT based opengl widget
 *
 * @author Paul Pantalone
 * @copyright Paul Pantalone. All Rights Reserved
 * @date 2018
 */
#pragma once

#include <QApplication>
#include <QFile>
#include <QFont>
#include <QProxyStyle>
#include <QStyleFactory>
#include <qtElements/export.h>

class PDPQTELEMENTS_EXPORT DarkStyle : public QProxyStyle
{
Q_OBJECT

public:
  DarkStyle();

  explicit DarkStyle(
    QStyle* style);

  QStyle* baseStyle() const;

  void polish(
    QPalette& palette) override;

  void polish(
    QApplication* app) override;

 private:
  QStyle *styleBase(
    QStyle* style = Q_NULLPTR) const;
};
