#pragma once

#include <QMouseEvent>
#include <QLabel>
#include <QTreeWidget>
#include <utilities/stringUtils.h>
#include <elements/Color.h>
#include <qtElements/export.h>

class NetworkTableWidget : public QTreeWidget
{
  Q_OBJECT

public:
  NetworkTableWidget(
    QWidget* parent);

  ~NetworkTableWidget();

  QTreeWidgetItem* createTableItem(
    int itemIdx,
    const std::string& type,
    const std::string& filter,
    const std::string& dimensions);

Q_SIGNALS:
  void sndLoadLayer(
    int idx);

protected:
  virtual void mousePressEvent(
    QMouseEvent* event);

  virtual void mouseDoubleClickEvent(
    QMouseEvent* event);

private:
  void setColumnHeader();

  void setColumnLayout();

private:
};
