/** @file
 *
 * QT based video widget
 *
 * @author Paul Pantalone
 * @copyright Paul Pantalone. All Rights Reserved
 * @date 2018
 */
#pragma once

#include <QPixmap>
#include <QWidget>
#include <QPainter>
#include <qtElements/export.h>

/**
 *
 * @ingroup qtElements
 */
class PDPQTELEMENTS_EXPORT VideoWidget : public QWidget
{
Q_OBJECT

public:
  explicit VideoWidget(
    QWidget* parent);

  ~VideoWidget() override;

  void displayFrame(
    const uchar* data,
    int width,
    int height);

  void clearFrame();

  void captureFrame(
    const QString& fileName);

protected:
  void paintEvent(
    QPaintEvent* paintEvent) override;

private:
  QPixmap m_pixmap;
};
