/** @file
 * 
 * Agent Class used to implement render / controller model objects into 2D views
 *
 * @author Paul Pantalone
 * @copyright Paul Pantalone. All Rights Reserved
 * @date 2018
 */
#pragma once

#include <render/RenderContext.h>
#include <render/export.h>

namespace pdp {

/**
 * An Agent is a pluggable part of a View, and defines how a model 
 * object is drawn and how it reacts to mouse events.
 *
 * @ingroup render
 */
class PDPRENDER_EXPORT Agent
{
public:
  /**
   * Destructs an Agent.
   */
  virtual ~Agent();
};

} // namespace pdp

