/** @file
 *
 * Time utility classes and functions
 *
 * @author Paul Pantalone
 * @copyright Paul Pantalone. All Rights Reserved
 * @date 2018
 */
#pragma once

#ifdef _WINDOWS
#include <windows.h>
#endif
#include <utilities/export.h>

#ifdef _WINDOWS
#define PdpFatalError(s) do {                                                             \
  std::stringstream _message;                                                             \
  _message << std::string(s) + "\n" << __FILE__ << ':' << __LINE__ << "\nAborting...\n";  \
  OutputDebugStringA(_message.str().c_str());                                             \
  exit(1);                                                                                \
} while(0)
#else
#define PdpFatalError(s) do {                                        \
  std::stringstream _message;                                        \
  _message << std::string(s) + "\n" << __FILE__ << ':' << __LINE__;  \
  std::cerr << _message.str() << "\nAborting...\n";                  \
  exit(1);                                                           \
} while(0)
#endif

namespace pdp
{
} // namespace pdp
